Program LogicSample;

Uses
  Graph;

   {= logical function, should be customized by students =}
Function F(x,y: single): boolean;
Var
  z: single;
begin
z:=abs(x)+abs(y);
F:=(z > 5) and (z < 10);
end;

Const
  Window_Width:  integer = 300;
  Window_Height: integer = 300;

Var
  Device, Mode: integer;
  N,i,j: integer;
  x,y, dx,dy: single;
  b: boolean;

begin
  {= Select area size (in pixels) as 0.5 * min(Height, Width) =}
N:=Window_Width div 2;
i:=Window_Height div 2;
if N>i then N:=i;

   {= Select "dx" and "dy" values so as "N pixels" ~ "10 units of X" =}
i:=N div 100;
if i<1 then i:=1;
dx:=0.1/i;
dy:=0.1/i;

  {= Start graphics mode =}
Device:=Detect;
InitGraph(Device, Mode, 'C:\BP\BGI');

  {= paint the areas =}
for i:=-N to N do
  for j:=-N to N do
    begin
    x:=i*dx;    { calculate absolute coordinates }
    y:=j*dx;

    b:=F(x,y);  { get boolean value for the (X,Y) point }

    if b        { colour the point }
    then PutPixel(i+N, j+N, White)
    else PutPixel(i+N, j+N, Black);
                {sample color names:
                  Black     White      Gray     LightGray
                  Red       Green      Blue
                  LightRed  LightGreen LightBlue
                  Yellow    Cyan       Brown     Magenta
                  }
    end;

  {= draw axes =}
SetColor(Magenta);

MoveTo(N,0);
LineTo(N,2*N);
MoveTo(0,N);
LineTo(2*N,N);

  {= draw labels on the X axis =}
j:=Trunc(1.0/dx);
for i:=1 to N div j do
  begin
  MoveTo(N-i*j, N+2);
  LineTo(N-i*j, N-2);
  MoveTo(N+i*j, N+2);
  LineTo(N+i*j, N-2);
  end;

  {= draw labels on the Y axis =}
j:=Trunc(1.0/dy);
for i:=1 to N div j do
  begin
  MoveTo(N+2, N-i*j);
  LineTo(N-2, N-i*j);
  MoveTo(N+2, N+i*j);
  LineTo(N-2, N+i*j);
  end;

  {= Allow a user to choose when to cancel application =}
SetColor(LightRed);
OutTextXY( GetMaxX div 2 - 100,
           GetMaxY - TextHeight('A')-4,
           'Press ENTER to exit the program...');
Readln;

  {= Exit graphics mode =}
CloseGraph;

END.
